def lunar_sum(a, b):
    max_len = max(len(a), len(b))
    a = a.zfill(max_len)
    b = b.zfill(max_len)
    result = ""
    for i in range(max_len):
        result += str(max(int(a[i]), int(b[i])))
    return result


def lunar_product(a, b):
    a_int = [int(x) for x in a]
    b_int = [int(x) for x in b]

    product_list = []

    for i, digit_b in enumerate(b_int):
        intermediate = []
        carry = 0
        for digit_a in a_int:
            min_val = min(digit_a, digit_b)
            intermediate.append(min_val)
        product_list.append(intermediate)

    result_length = len(a_int) + len(b_int) - 1
    result = [0] * result_length

    for i, intermediate_product in enumerate(product_list):
        for j, digit in enumerate(intermediate_product):
            result[i + j] = max(result[i + j], digit)

    return "".join(map(str, result))


a = input()
b = input()

sum_result = lunar_sum(a, b)
product_result = lunar_product(a, b)

print(sum_result, product_result)
