import heapq


def solve():
    n, m, k = map(int, input().split())
    edges = []
    for _ in range(m):
        u, v = map(int, input().split())
        edges.append((u - 1, v - 1))

    guards = []
    for _ in range(k):
        p, h = map(int, input().split())
        guards.append((p - 1, h))

    adj = [[] for _ in range(n)]
    for u, v in edges:
        adj[u].append(v)
        adj[v].append(u)

    def dijkstra(start):
        dist = [-1] * n
        dist[start] = 0
        pq = [(0, start)]

        while pq:
            d, u = heapq.heappop(pq)
            if d > dist[u]:
                continue
            for v in adj[u]:
                if dist[v] == -1 or dist[v] > dist[u] + 1:
                    dist[v] = dist[u] + 1
                    heapq.heappush(pq, (dist[v], v))
        return dist

    protected = set()
    for guard_pos, guard_range in guards:
        distances = dijkstra(guard_pos)
        for i in range(n):
            if distances[i] != -1 and distances[i] <= guard_range:
                protected.add(i + 1)

    protected_list = sorted(list(protected))
    print(len(protected_list))
    if len(protected_list) > 0:
        print(*protected_list)


solve()
