import heapq

def solve():
    n, m, k = map(int, input().split())
    edges = []
    for _ in range(m):
        u, v = map(int, input().split())
        edges.append((u-1, v-1))

    guards = []
    for _ in range(k):
        p, h = map(int, input().split())
        guards.append((p - 1, h))

    adj = [[] for _ in range(n)]
    for u, v in edges:
        adj[u].append(v)
        adj[v].append(u)

    protected = set()
    for guard_pos, guard_range in guards:
        q = [(0, guard_pos)] # (расстояние, узел)
        visited = {guard_pos}
        while q:
            dist, curr = heapq.heappop(q)
            if dist > guard_range:
                continue
            protected.add(curr + 1)
            for neighbor in adj[curr]:
                if neighbor not in visited:
                    visited.add(neighbor)
                    heapq.heappush(q, (dist + 1, neighbor))

    protected_list = sorted(list(protected))
    print(len(protected_list))
    if protected_list:
        print(*protected_list)

solve()
