import itertools
import math

def dist(p1, p2):
  return math.sqrt((p1[0] - p2[0])**2 + (p1[1] - p2[1])**2)

def solve():
  n = int(input())
  points = []
  for _ in range(n):
    x, y = map(int, input().split())
    points.append((x, y))

  min_dist = float('inf')
  for start_point in points:
    for perm in itertools.permutations(points):
      if perm[0] != start_point:
        continue

      cur_dist = 0
      cur_point = start_point
      for p in perm:
        cur_dist += dist(cur_point, p)
        cur_point = p
      min_dist = min(min_dist, cur_dist)

  print(f"{round(min_dist, 12)}") #Round to 12 decimal places

solve()
